using System;
using System.Runtime.InteropServices;
using System.ComponentModel;

namespace Bon
{
	[ComVisible(true)]
	[Guid("517EB803-A401-4a59-A0E1-A0F753E76637")]
	[Flags]
	public enum EpgDataStates
	{
		Empty = 0x00,				// f[^Ȃ
		EventIDStored = 0x01,		// EVENT IDXgAς
		ShortInfoStored = 0x02,		// Z`CxgXgAς
		ExtendInfoStored = 0x04,	// g`CxgXgAς
		VideoInfoStored = 0x08,		// fXgAς
		AudioInfoStored = 0x10,		// XgAς
		ContentInfoStored = 0x20,	// RegXgAς
		ScheduleChanged	= 0x40,		// XPW[ωo
		InfomationCompleted = (EventIDStored | ShortInfoStored | ExtendInfoStored | VideoInfoStored | AudioInfoStored)
	};

	[ComVisible(true)]
	[Guid("D1F4A7B8-5AC9-4601-980C-6CCD1D4796F4")]
	public enum AudioModes
	{
		Undefined = 0x00,	// `
		Monoral = 0x01,		// m
		Dual = 0x02,		// d
		Stereo = 0x03,		// XeI
		Surround = 0x04		// TEh
	};

	[ComVisible(true)]
	[Guid("9A790CF4-114D-497d-9249-25EA8468FB2D")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	[TypeConverter(typeof(ExpandableObjectConverter))]
	public interface IEpgData
	{
		EpgDataStates EpgDataStatus
		{
			get;
		}

		///////////////////////////////
		// EventIDStored ŗL

		int EventID
		{
			get;
		}

		DateTime StartTime
		{
			get;
		}

		TimeSpan Duration
		{
			get;
		}

		bool IsScrambled
		{
			get;
		}

		///////////////////////////////
		// ShortInfoStored ŗL

		string EventTitle
		{
			get;
		}

		string EventInfo
		{
			get;
		}

		///////////////////////////////
		// ExtendInfoStored ŗL

		string EventDetail
		{
			get;
		}

		///////////////////////////////
		// VideoInfoStored ŗL

		int VideoResolution
		{
			get;
		}

		bool IsVideoProgressive
		{
			get;
		}

		bool IsVideoAspectWide
		{
			get;
		}

		bool IsVideoPanAndScan
		{
			get;
		}

		///////////////////////////////
		// AudioInfoStored ŗL
		AudioModes AudioMode
		{
			get;
		}

		///////////////////////////////
		// ContentInfoStored ŗL

		int Genre
		{
			get;
		}

		int GetGenreLevel1(int index);
		int GetGenreLevel2(int index);
	}
}
