using System;
using System.Runtime.InteropServices;
using System.ComponentModel;

namespace Bon
{
	[ComVisible(true)]
	[Guid("9E9DFB25-585A-4ebc-9AB3-D1A1ADDC1CB9")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	[TypeConverter(typeof(ExpandableObjectConverter))]
	public interface IRemoteTuner
	{
		string TunerName
		{
			get;
		}

		string DeviceName
		{
			get;
		}

		ITuningSpaceInformation[] TuningSpaces
		{
			get;
		}

		int DeviceID
		{
			get;
		}

		bool IsRunning
		{
			get;
		}

		byte[] BcasCardID
		{
			get;
		}

		bool EnableEmmProcess
		{
			get;
			set;
		}

		bool EnableLnbPower
		{
			get;
			set;
		}

		float SignalLevel
		{
			get;
		}

		int TuningSpace
		{
			get;
			set;
		}

		int Channel
		{
			get;
			set;
		}

		int NetworkID
		{
			get;
		}

		string NetworkName
		{
			get;
		}

		int TransportStreamID
		{
			get;
		}

		DateTime StreamTime
		{
			get;
		}

		IProgramInformation[] Programs
		{
			get;
		}

		int ProgramID
		{
			get;
			set;
		}

		DescramblingStates DescramblingStatus
		{
			get;
		}
	}
}
