using System;
using System.Runtime.InteropServices;
using System.ComponentModel;

namespace Bon
{
	[ComVisible(true)]
	[Guid("428586CC-0B11-4828-BB59-988827953A7E")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	[TypeConverter(typeof(ExpandableObjectConverter))]
	public interface ITuner : IDisposable
	{
		string TunerName
		{
			get;
		}

		string DeviceName
		{
			get;
		}

		ITuningSpaceInformation[] TuningSpaces
		{
			get;
		}

		int DeviceID
		{
			get;
		}

		bool IsRunning
		{
			get;
		}

		byte[] BcasCardID
		{
			get;
		}

		bool EnableEmmProcess
		{
			get;
			set;
		}

		bool EnableLnbPower
		{
			get;
			set;
		}

		float SignalLevel
		{
			get;
		}

		int TuningSpace
		{
			get;
			set;
		}

		int Channel
		{
			get;
			set;
		}

		int NetworkID
		{
			get;
		}

		string NetworkName
		{
			get;
		}

		int TransportStreamID
		{
			get;
		}

		DateTime StreamTime
		{
			get;
		}

		IProgramInformation[] Programs
		{
			get;
		}

		int ProgramID
		{
			get;
			set;
		}

		DescramblingStates DescramblingStatus
		{
			get;
		}

		IDataQueue CreateQueue(long maxSize);
	}
}
