
#pragma once

namespace Bon
{
	ref class Tuner;

	ref class DataQueue sealed
		: public IDataQueue
	{
	private:
		Tuner^ parent_;
		initonly __int64 maxSize_;
		initonly System::Collections::Generic::Queue<ITsData^>^ queue_;
		initonly System::Threading::ManualResetEvent^ queued_;
		__int64 totalSize_;

	internal:
		DataQueue(Tuner^ parent, __int64 maxSize);

		void Enqueue(ITsData^ data);
		void Close();

	public:
		~DataQueue();

		virtual void Clear();

		property System::Threading::WaitHandle^ CanDequeue
		{
			virtual System::Threading::WaitHandle^ get();
		}

		property System::IntPtr CanDequeueHandle
		{
			virtual System::IntPtr get();
		}

		property int Count
		{
			virtual int get();
		}

		property __int64 MaxSize
		{
			virtual __int64 get();
		}

		property __int64 TotalSize
		{
			virtual __int64 get();
		}

		virtual ITsData^ Dequeue();

		virtual IRawTsData^ RawDequeue();
	};
}
