
#pragma once

#include "ManagedBuffer.h"

namespace Bon
{
	ref class DataQueue;
	ref class Tuner;

	namespace Internal
	{
		class DataQueueManager : public CMediaDecoder
		{
		private:
			ManagedBuffer buffer_;
			int position_;
			gcroot<System::Collections::Generic::List<DataQueue^>^> queueList_;

			DataQueueManager(const DataQueueManager &);
			void operator =(const DataQueueManager &);

		protected:
			virtual const bool OnPlay();
			virtual const bool OnStop();
			virtual const bool OnReset();
			virtual const bool OnInputMedia(const IMediaData *pMediaData, const DWORD dwInputIndex = 0UL);

		public:
			DataQueueManager(IBonObject *pOwner = 0, int bufferSize = 1000000);
			~DataQueueManager();

			DECLARE_IBONOBJECT(DataQueueManager)

			void Clear();

			System::Collections::Generic::KeyValuePair<IDataQueue^, int>
				CreateQueue(Tuner^ parent, __int64 maxSize);
			int RemoveQueue(DataQueue^ queue);
		};
	}
}
