
#pragma once

namespace Bon
{
	ref class EpgData
		: public System::Runtime::ConstrainedExecution::CriticalFinalizerObject,
		public IEpgData
	{
	private:
		IEpgItem *pEpgItem_;

	internal:
		EpgData(const IEpgItem *pEpgItem);

	public:
		~EpgData();

		property EpgDataStates EpgDataStatus
		{
			virtual EpgDataStates get();
		}

		property int EventID
		{
			virtual int get();
		}

		property System::DateTime StartTime
		{
			virtual System::DateTime get();
		}

		property System::TimeSpan Duration
		{
			virtual System::TimeSpan get();
		}

		property bool IsScrambled
		{
			virtual bool get();
		}

		property System::String^ EventTitle
		{
			virtual System::String^ get();
		}

		property System::String^ EventInfo
		{
			virtual System::String^ get();
		}

		property System::String^ EventDetail
		{
			virtual System::String^ get();
		}

		property int VideoResolution
		{
			virtual int get();
		}

		property bool IsVideoProgressive
		{
			virtual bool get();
		}

		property bool IsVideoAspectWide
		{
			virtual bool get();
		}

		property bool IsVideoPanAndScan
		{
			virtual bool get();
		}

		property AudioModes AudioMode
		{
			virtual AudioModes get();
		}

		property int Genre
		{
			virtual int get();
		}

		virtual int GetGenreLevel1(int index);
		virtual int GetGenreLevel2(int index);
	};
}
