
#include "stdafx.h"

#include "ManagedBuffer.h"

namespace Bon
{
	namespace Internal
	{
		void ManagedBuffer::Allocate()
		{
			array<System::Byte>^ buffer = gcnew array<System::Byte>(bufferSize_);
			System::Runtime::InteropServices::GCHandle handle(
				System::Runtime::InteropServices::GCHandle::Alloc(buffer,
				System::Runtime::InteropServices::GCHandleType::Pinned));
			handle_ = System::Runtime::InteropServices::GCHandle::ToIntPtr(handle).ToPointer();
			pBuffer_ = static_cast<BYTE *>(handle.AddrOfPinnedObject().ToPointer());
		}

		void ManagedBuffer::Free()
		{
			System::Runtime::InteropServices::GCHandle handle(
				System::Runtime::InteropServices::GCHandle::FromIntPtr(System::IntPtr(handle_)));
			handle.Free();
		}

		ManagedBuffer::ManagedBuffer(int bufferSize)
			: handle_(0), pBuffer_(0), bufferSize_(bufferSize)
		{
			Allocate();
		}

		ManagedBuffer::~ManagedBuffer()
		{
			Free();
		}

		const int ManagedBuffer::GetSize() const
		{
			return bufferSize_;
		}

		const BYTE *ManagedBuffer::GetData() const
		{
			return pBuffer_;
		}

		BYTE *ManagedBuffer::GetData()
		{
			return pBuffer_;
		}

		array<System::Byte>^ ManagedBuffer::GetManagedData()
		{
			System::Runtime::InteropServices::GCHandle handle(
				System::Runtime::InteropServices::GCHandle::FromIntPtr(System::IntPtr(handle_)));
			return static_cast<array<System::Byte>^>(handle.Target);
		}

		void ManagedBuffer::Renew()
		{
			Free();
			Allocate();
		}
	}
}
