
#include "stdafx.h"

#include "TsData.h"
#include "RawTsData.h"

namespace Bon
{
	RawTsData::RawTsData(ITsData^ data)
		: data_(data),
		handle_(System::Runtime::InteropServices::GCHandle::Alloc(data->Data, System::Runtime::InteropServices::GCHandleType::Pinned))
	{
	}

	RawTsData::~RawTsData()
	{
		if (data_ != nullptr)
		{
			handle_.Free();
			data_ = nullptr;
		}
	}

	int RawTsData::Size::get()
	{
		return data_->Size;
	}

	array<System::Byte>^ RawTsData::Data::get()
	{
		return data_->Data;
	}

	System::IntPtr RawTsData::RawData::get()
	{
		return handle_.AddrOfPinnedObject();
	}
}
