
#pragma once

namespace Bon
{
	namespace Internal
	{
		class DataQueueManager;
	}

	ref class DataQueue;

	ref class Tuner sealed
		: public System::Runtime::ConstrainedExecution::CriticalFinalizerObject,
		public ITuner
	{
	private:
		initonly ITunerDefinition^ tunerDefinition_;
		ITsSourceTuner *pTsSourceTuner_;
		ITsPacketSync *pTsPacketSync_;
		IProgAnalyzer *pProgAnalyzer_;
		ITsDescrambler *pTsDescrambler_;
		Internal::DataQueueManager *pManager_;
		bool running_;
		bool enableEmmProcess_;
		bool enableLnbPower_;
		array<ITuningSpaceInformation^>^ tuningSpaces_;

	internal:
		Tuner(ITunerDefinition^ tunerDefinition);

		void RemoveQueue(DataQueue^ queue);

	public:
		~Tuner();

		property System::String^ TunerName
		{
			virtual System::String^ get();
		}

		property System::String^ DeviceName
		{
			virtual System::String^ get();
		}

		property int DeviceID
		{
			virtual int get();
		}

		property array<ITuningSpaceInformation^>^ TuningSpaces
		{
			virtual array<ITuningSpaceInformation^>^ get();
		}

		property bool IsRunning
		{
			virtual bool get();
		}

		property array<System::Byte>^ BcasCardID
		{
			virtual array<System::Byte>^ get();
		}

		property bool EnableEmmProcess
		{
			virtual bool get();
			virtual void set(bool value);
		}

		property bool EnableLnbPower
		{
			virtual bool get();
			virtual void set(bool value);
		}

		property float SignalLevel
		{
			virtual float get();
		}

		property int TuningSpace
		{
			virtual int get();
			virtual void set(int);
		}

		property int Channel
		{
			virtual int get();
			virtual void set(int);
		}

		property int NetworkID
		{
			virtual int get();
		}

		property System::String^ NetworkName
		{
			virtual System::String^ get();
		}

		property int TransportStreamID
		{
			virtual int get();
		}

		property System::DateTime StreamTime
		{
			virtual System::DateTime get();
		}

		property array<IProgramInformation^>^ Programs
		{
			virtual array<IProgramInformation^>^ get();
		}

		property int ProgramID
		{
			virtual int get();
			virtual void set(int value);
		}

		property DescramblingStates DescramblingStatus
		{
			virtual DescramblingStates get();
		}

		virtual IDataQueue^ CreateQueue(__int64 maxSize);
	};
}
