// BonBaseIf.h: x[XC^tF[X`
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


namespace Bon
{

/////////////////////////////////////////////////////////////////////////////
// BonIuWFNgC^tF[X
/////////////////////////////////////////////////////////////////////////////

class IBonObject
{
public:
	virtual void Release(void) = 0;
	virtual const BONGUID GetGuid(void) const = 0;
};


/////////////////////////////////////////////////////////////////////////////
// NXt@Ng[\bh^
/////////////////////////////////////////////////////////////////////////////

typedef IBonObject * (* CLASSFACTORYMETHOD)(IBonObject *pOwner);


/////////////////////////////////////////////////////////////////////////////
// BonRAGWC^tF[X
/////////////////////////////////////////////////////////////////////////////

class CBonString;

class IBonCoreEngine : public IBonObject
{
public:
	virtual const BONGUID BonNameToGuid(LPCTSTR lpszName) = 0;
	virtual IBonObject * BonCreateInstance(LPCTSTR lpszClassName, IBonObject *pOwner) = 0;

	virtual const bool RegisterBonModule(LPCTSTR lpszModulePath = NULL) = 0;
	virtual const bool QueryBonModule(LPCTSTR lpszModuleName) = 0;
	virtual const DWORD GetBonModuleNum(void) = 0;
	virtual const BONGUID EnumBonModule(const DWORD dwIndex) = 0;
	virtual const CBonString GetBonModuleName(const BONGUID ModuleId) = 0;
	virtual const BONGUID EnumBonModuleClass(const BONGUID ModuleId, const DWORD dwIndex) = 0;

	virtual const bool RegisterBonClass(LPCTSTR lpszClassName, const CLASSFACTORYMETHOD pfnClassFactory, const DWORD dwPriority = 0UL) = 0;
	virtual const bool QueryBonClass(LPCTSTR lpszClassName) = 0;
	virtual const DWORD GetBonClassNum(void) = 0;
	virtual const BONGUID EnumBonClass(const DWORD dwIndex) = 0;
	virtual const CBonString GetBonClassName(const BONGUID ClassId) = 0;
	virtual const DWORD GetBonClassPriority(const BONGUID ClassId) = 0;
	virtual const BONGUID GetBonClassModule(const BONGUID ClassId) = 0;

	virtual IBonObject * GetStockInstance(LPCTSTR lpszClassName) = 0;
	virtual const bool RegisterStockInstance(LPCTSTR lpszClassName, IBonObject *pInstance) = 0;
	virtual const bool UnregisterStockInstance(LPCTSTR lpszClassName) = 0;
	virtual const CBonString EnumStockInstance(const DWORD dwIndex) = 0;
};


/////////////////////////////////////////////////////////////////////////////
// BonW[J^OC^tF[X
/////////////////////////////////////////////////////////////////////////////

class IBonModCatalog : public IBonObject
{
public:
	virtual const WORD GetVersion(void) const = 0;
	virtual const CBonString GetComment() const = 0;
	virtual const CBonString GetAuthor() const = 0;
	virtual const CBonString GetWebsite() const = 0;
	virtual const BONGUID EnumClass(LPCTSTR lpszBIId, const DWORD dwIndex) const = 0;
	virtual const CBonString GetClassDesc(const BONGUID ClassId) const = 0;
};


/////////////////////////////////////////////////////////////////////////////
// BonNX񋓃C^tF[X
/////////////////////////////////////////////////////////////////////////////

class IBonClassEnumerator : public IBonObject
{
public:
	virtual const DWORD EnumBonClass(LPCTSTR lpszBIId) = 0;
	virtual const DWORD GetBonClassNum(void) const = 0;
	
	virtual const CBonString GetBonModuleName(DWORD dwIndex) const = 0;
	virtual const CBonString GetBonClassName(DWORD dwIndex) const = 0;
	virtual const CBonString GetBonClassDesc(DWORD dwIndex) const = 0;
	virtual const CBonString GetBonModuleComment(DWORD dwIndex) const = 0;
	virtual const CBonString GetBonModuleAuthor(DWORD dwIndex) const = 0;
	virtual const CBonString GetBonModuleWebsite(DWORD dwIndex) const = 0;
};

}
