// BonDebug.h: fobO⏕Cu
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


namespace Bon
{

#ifdef _DEBUG
	// fobOrh
	#define BON_IS_DEBUG	true
#else
	// [Xrh
	#define BON_IS_DEBUG	false
#endif



/////////////////////////////////////////////////////////////////////////////
// ėpONX
/////////////////////////////////////////////////////////////////////////////

class BONAPI CBonException
{
public:
	CBonException(LPCSTR lpszSourceFile, const DWORD dwSourceLine, const BONGUID ClassId);
	virtual ~CBonException(void);

	CBonException & operator( )(LPCTSTR lpszFormat = NULL, ...);

	void Notify(const bool bEnable = BON_IS_DEBUG) const;

	const BONGUID GetGuid(void) const;
	const CBonString GetDescription() const;
	const CBonString GetSourceFile() const;
	const DWORD GetSourceLine(void) const;

protected:
	const BONGUID m_ClassId;
	CBonString m_Description;
	CBonString m_SourceFile;
	const DWORD m_dwSourceLine;
};


/////////////////////////////////////////////////////////////////////////////
// ėpƍNX
/////////////////////////////////////////////////////////////////////////////

class BONAPI CBonAssert
{
public:
	CBonAssert(LPCSTR lpszSourceFile, const DWORD dwSourceLine, const BONGUID ClassId);

	void operator( )(const bool bSuccess = false, LPCTSTR lpszFormat = NULL, ...);
	void operator( )(const void *pPointer, LPCTSTR lpszFormat = NULL, ...);
	
protected:
	const BONGUID m_ClassId;
	LPCSTR m_lpszSourceFile;
	const DWORD m_dwSourceLine;
};


/*


class CPerfInspector
{
protected:
	class CPerfInitializer
	{
	public:
		CPerfInitializer()
		{
			::BON_TRACE(TEXT("CPerfInitializer()\n"));
			::QueryPerformanceFrequency((LARGE_INTEGER *)&m_llCounterFreq);
		}
	
		LONGLONG m_llCounterFreq;
	};

public:
	CPerfInspector()
	{
		::QueryPerformanceCounter((LARGE_INTEGER *)&m_llStartTime);
	}
	
	~CPerfInspector()
	{
		LONGLONG m_llEndTime = m_llStartTime;
		::QueryPerformanceCounter((LARGE_INTEGER *)&m_llEndTime);

		m_llEndTime = ((m_llEndTime - m_llStartTime) * 1000000LL) / m_PerfCounter.m_llCounterFreq;
		
		::BON_TRACE(TEXT("Block Process Time = %luus\n"), (DWORD)m_llEndTime);		
	}

protected:
	LONGLONG m_llStartTime;
	static CPerfInitializer m_PerfCounter;
};

CPerfInspector::CPerfInitializer CPerfInspector::m_PerfCounter;




*/







/////////////////////////////////////////////////////////////////////////////
// fobO⏕֐
/////////////////////////////////////////////////////////////////////////////

extern "C" BONAPI const BONGUID GetGuid(void);
extern "C" BONAPI void BON_TRACE(LPCTSTR lpszFormat, ...);


/////////////////////////////////////////////////////////////////////////////
// fobO⏕}N
/////////////////////////////////////////////////////////////////////////////

#define BON_EXPECTION	CBonException(__FILE__, __LINE__, GetGuid())
#define BON_ASSERT		CBonAssert(__FILE__, __LINE__, GetGuid())

}
