// BonDebug.cpp: fobO⏕Cu
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include <TChar.h>
#include <StdLib.h>


namespace Bon
{

/////////////////////////////////////////////////////////////////////////////
// ėpONX
/////////////////////////////////////////////////////////////////////////////

CBonException::CBonException(LPCSTR lpszSourceFile, const DWORD dwSourceLine, const BONGUID ClassId)
	: m_ClassId(ClassId)
	, m_SourceFile(lpszSourceFile)
	, m_dwSourceLine(dwSourceLine)
	, m_Description(TEXT("OɊւ͂܂"))
{
}

CBonException::~CBonException(void)
{
	// Ȃ
}

CBonException & CBonException::operator( )(LPCTSTR lpszFormat, ...)
{
	// 
	va_list Args;
	va_start(Args ,lpszFormat);
	TCHAR szDescription[1024];
	::_vstprintf(szDescription, lpszFormat, Args);
	m_Description = szDescription;
	va_end(Args);
	
	return *this;
}

void CBonException::Notify(const bool bEnable) const
{
	// Oʒm
	TCHAR szOutput[1024] = TEXT("");

	// \[Xt@C擾
	CBonString source = GetSourceFile();

	if(m_ClassId != BCID_NULL){
		CBonString moduleName = TEXT("s");
		CBonString className = TEXT("s");
		
		// NX擾
		::GET_BON_CLASS_NAME(m_ClassId, &className);
		
		// W[擾
		::GET_BON_MODULE_NAME(::GET_BON_CLASS_MODULE(m_ClassId), &moduleName);
		
		// fobOo͕񐶐
		::_stprintf(szOutput, TEXT("[OCxg]\r\n@Eꏊ\tF %sW[@%sNX\r\n@E\[X\tF %s@%lu s\r\n@E\tF %s\r\n"), moduleName.GetString(), className.GetString(), source.GetString(), m_dwSourceLine, m_Description.GetString());
		}
	else{
		// fobOo͕񐶐
		::_stprintf(szOutput, TEXT("[OCxg]\r\n@Eꏊ\tF O[o͔BonNX\r\n@E\[X\tF %s@%lu s\r\n@E\tF %s\r\n"), source.GetString(), m_dwSourceLine, m_Description.GetString());
		}

	// fobOo
	::OutputDebugString(szOutput);

	// CxgOɏo
		// ܂

	// [Uɒʒm
	if(bEnable){
		::_tcscat(szOutput, TEXT("\r\n\r\nO𖳎ăvO̎sp܂H"));

		if(::MessageBox(NULL, szOutput, TEXT("BonSDK Oʒm"), MB_YESNO | MB_ICONERROR | MB_TASKMODAL) == IDYES){
			// sp
			return;
			}

		// fobOu[N
		::DebugBreak();
		}
}

const BONGUID CBonException::GetGuid(void) const
{
	// OBONGUIDԂ
	return m_ClassId;
}

const CBonString CBonException::GetDescription() const
{
	return m_Description;
}

const CBonString CBonException::GetSourceFile() const
{
	// Õ\[Xt@CԂ
	TCHAR szPathName[_MAX_PATH] = TEXT("");
	TCHAR szFileName[_MAX_FNAME] = TEXT("");
	TCHAR szExtName[_MAX_EXT] = TEXT("");

	// t@C𒊏o
	::_tsplitpath(m_SourceFile, NULL, NULL, szFileName, szExtName);
	::_tmakepath(szPathName, NULL, NULL, szFileName, szExtName);	

	return szPathName;
}

const DWORD CBonException::GetSourceLine(void) const
{
	// Õ\[XR[hsԂ
	return m_dwSourceLine;
}


/////////////////////////////////////////////////////////////////////////////
// ėpƍNX
/////////////////////////////////////////////////////////////////////////////

CBonAssert::CBonAssert(LPCSTR lpszSourceFile, const DWORD dwSourceLine, const BONGUID ClassId)
	: m_lpszSourceFile(lpszSourceFile)
	, m_dwSourceLine(dwSourceLine)
	, m_ClassId(ClassId)
{
	// Ȃ
}

void CBonAssert::operator( )(const bool bSuccess, LPCTSTR lpszFormat, ...)
{
	// 
	if(!bSuccess){
		// OIuWFNg
		CBonException Exception(m_lpszSourceFile, m_dwSourceLine, m_ClassId);
		
		if(lpszFormat){
			TCHAR szDescription[1024] = TEXT("");

			// tH[}bg
			va_list Args;
			va_start(Args , lpszFormat);
			::_vstprintf(szDescription, lpszFormat, Args);
			va_end(Args);
			Exception(szDescription);
			}

		// O𔭐
		Exception.Notify();
		}
}

void CBonAssert::operator( )(const void *pPointer, LPCTSTR lpszFormat, ...)
{
	// |C^
	if(!pPointer){
		// OIuWFNg
		CBonException Exception(m_lpszSourceFile, m_dwSourceLine, m_ClassId);
		
		if(lpszFormat){
			TCHAR szDescription[1024] = TEXT("");

			// tH[}bg
			va_list Args;
			va_start(Args , lpszFormat);
			::_vstprintf(szDescription, lpszFormat, Args);
			va_end(Args);
			Exception(szDescription);
			}

		// O𔭐
		Exception.Notify();
		}
}


/////////////////////////////////////////////////////////////////////////////
// fobO⏕֐
/////////////////////////////////////////////////////////////////////////////

extern "C" const BONGUID GetGuid(void)
{
	// O[oXR[v̏ꍇBCID_NULLԂ
	return BCID_NULL;
}

extern "C" void BON_TRACE(LPCTSTR lpszFormat, ...)
{
#ifdef _DEBUG
	TCHAR szOutput[1024] = TEXT("");

	// bZ[W
	va_list Args;
	va_start(Args , lpszFormat);
	::_vstprintf(szOutput, lpszFormat, Args);
	va_end(Args);

	// fobOo͂ɏ
	::OutputDebugString(szOutput);
#endif
}

}
