// BonWhiteTuner.cpp: Friio`[i[NX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "Resource.h"
#include "BonSDK.h"
#include "BonWhiteTuner.h"
#include <Math.h>
#include <TChar.h>


/////////////////////////////////////////////////////////////////////////////
// t@C[J萔ݒ
/////////////////////////////////////////////////////////////////////////////

// foCX
#define DEVICENAME	TEXT(" Friio USB 2.0 Digital TV Receiver")

// I/ORg[R[h
#define IOCODE_CONTROL		0x00220020UL	// `[iRg[
#define IOCODE_SETTSSIZE	0x00220038UL	// TSXg[TCYݒ
#define IOCODE_ABORTPIPE	0x00220044UL	// TSXg[~
#define IOCODE_STREAM		0x0022004BUL	// Xg[NGXg


/////////////////////////////////////////////////////////////////////////////
// Friiop@TS`[i HALC^tF[XNX
/////////////////////////////////////////////////////////////////////////////

const CBonString CBonWhiteTuner::GetDeviceName() const
{
	static const CBonString deviceName(DEVICENAME);

	// foCXԂ
	return deviceName;
}

const bool CBonWhiteTuner::OnOpenTuner(void)
{
	try
	{
		// hCo
		if(!m_BonEnumerator.EnumDevice(false))throw __LINE__;
	}
	catch (...)
	{
		// G[
		return false;
	}
	
	return true;
}

const CBonString CBonWhiteTuner::EnumTuningSpace(const DWORD dwSpace) const
{
	static const CBonString tuningSpace[1] = 
	{
		CBonString(TEXT("nfW"))
	};

	// gp\ȃ`[jOԂԂ
	if(dwSpace >= 1) return CBonString::GetEmpty();

	// `[jOԖԂ
	return tuningSpace[dwSpace];
}

const CBonString CBonWhiteTuner::EnumChannelName(const DWORD dwSpace, const DWORD dwChannel) const
{
	// gp\ȃ`lԂ
	if(dwSpace >= 1)return CBonString::GetEmpty();
	if(dwChannel >= (62 - 13 + 1))return CBonString::GetEmpty();

	// `lԂ
	return CBonString::Format(TEXT("UHF %1!ld!ch"), dwChannel + 13);
}

const bool CBonWhiteTuner::OnSetChannel(const DWORD dwSpace, const DWORD dwChannel)
{
	// `[jOV[PXϕ
	static const BYTE abyPllConfA[] = {0x81U};
	static const BYTE abyPllConfB[] = {0x40U, 0x03U, 0x00U, 0x30U, 0xFEU, 0x00U, 0x05U, 0x00U, 0x0AU, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x26U, 0x00U, 0x00U, 0x00U, 0x05U, 0x00U, 0x00U, 0x00U, 0xC0U, 0x00U, 0x00U, 0xB2U, 0x08U};
	static const BYTE abyPllConfC[] = {0x40U, 0x03U, 0x00U, 0x30U, 0xFEU, 0x00U, 0x05U, 0x00U, 0x0AU, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x26U, 0x00U, 0x00U, 0x00U, 0x05U, 0x00U, 0x00U, 0x00U, 0xC0U, 0x00U, 0x00U, 0x9AU, 0x50U};
	static const BYTE abyPllConfD[] = {0xC0U, 0x02U, 0x00U, 0x30U, 0xB0U, 0x00U, 0x01U, 0x00U, 0x0AU, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x26U, 0x00U, 0x00U, 0x00U, 0x01U, 0x00U, 0x00U, 0x00U, 0x00U};
	static const BYTE abyPllConfE[] = {0xC0U, 0x02U, 0x00U, 0x30U, 0x80U, 0x00U, 0x01U, 0x00U, 0x0AU, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x26U, 0x00U, 0x00U, 0x00U, 0x01U, 0x00U, 0x00U, 0x00U, 0x00U};
	static const BYTE abyPllConfF[] = {0x81U, 0x00U, 0xBCU, 0x00U, 0x00U};

	// `lf[^vZ
	const WORD wChCode = 0x0E7F + 0x002A * (WORD)dwChannel;

	BYTE TxdData[256];
	BYTE RxdBuff[256];

	// 1ڃNGXgM
	if(SendIoRequest(IOCODE_ABORTPIPE, abyPllConfA, sizeof(abyPllConfA), RxdBuff, 0UL) == -1)return false;
	if(SendIoRequest(IOCODE_ABORTPIPE, abyPllConfA, sizeof(abyPllConfA), RxdBuff, 0UL) == -1)return false;

	// 2ڃNGXgݒ
	::CopyMemory(TxdData, abyPllConfB, sizeof(abyPllConfB));
	TxdData[39] = (BYTE)(wChCode >> 8);
	TxdData[40] = (BYTE)(wChCode & 0xFF);

	// 2ڃNGXgM
	if(SendIoRequest(IOCODE_CONTROL, TxdData, sizeof(abyPllConfB), RxdBuff, sizeof(abyPllConfB)) == -1)return false;

	// 3ڃNGXgݒ
	CopyMemory(TxdData, abyPllConfC, sizeof(abyPllConfC));
	TxdData[39] = (BYTE)(wChCode >> 8);
	TxdData[40] = (BYTE)(wChCode & 0xFF);

	// 3ڃNGXgM
	if(SendIoRequest(IOCODE_CONTROL, TxdData, sizeof(abyPllConfC), RxdBuff, sizeof(abyPllConfC)) == -1)return false;

	// 4ڃNGXgM
	if(SendIoRequest(IOCODE_CONTROL, abyPllConfD, sizeof(abyPllConfD), RxdBuff, sizeof(abyPllConfD)) == -1)return false;

	// 5ڃNGXgM
	if(SendIoRequest(IOCODE_CONTROL, abyPllConfE, sizeof(abyPllConfE), RxdBuff, sizeof(abyPllConfE)) == -1)return false;

	// 6ڃNGXgM
	if(SendIoRequest(IOCODE_SETTSSIZE, abyPllConfF, sizeof(abyPllConfF), RxdBuff, sizeof(abyPllConfF)) == -1)return false;

	return true;
}

const float CBonWhiteTuner::GetSignalLevel(void) const
{
	// Mxv
	static const BYTE abyGetLevReq[] = {0xC0U, 0x02U, 0x00U, 0x30U, 0x89U, 0x00U, 0x25U, 0x00U, 0x0AU, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x26U, 0x00U, 0x00U, 0x00U, 0x25U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x31U, 0x3AU, 0x4BU, 0x03U, 0x00U, 0x34U, 0x08U, 0x78U, 0x00U, 0x00U, 0x40U, 0x7FU, 0xDCU, 0xACU, 0x0FU, 0x00U, 0x00U, 0x00U, 0x01U, 0xE3U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x02U, 0x00U, 0x02U, 0x00U, 0x02U, 0x00U, 0x00U, 0xF4U};

	// Mobt@NA
	BYTE RxdBuff[256];
	::ZeroMemory(RxdBuff, sizeof RxdBuff);

	// Mxv
	if(SendIoRequest(IOCODE_CONTROL, (BYTE *)abyGetLevReq, sizeof(abyGetLevReq), RxdBuff, sizeof(abyGetLevReq)) == -1)return 0.0f;

	// MxvZ
	const DWORD dwHex = ((DWORD)RxdBuff[40] << 16) | ((DWORD)RxdBuff[41] << 8) | (DWORD)RxdBuff[42];
	if(!dwHex)return 0.0f;

	return (float)(68.4344993f - log10((double)dwHex) * 10.0f + pow(log10((double)dwHex) - 5.045f, (double)4.0f) / 4.09f);
}

CBonWhiteTuner::CBonWhiteTuner(IBonObject *pOwner)
	: CBonTunerBase(pOwner, IDR_INISEQ_WHITE, IDR_ENDSEQ_WHITE)
{

}
