// FileWriter.h: t@CC^fR[_
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


#include <Vector>
#include <Queue>


/////////////////////////////////////////////////////////////////////////////
// t@CC^fR[_
/////////////////////////////////////////////////////////////////////////////
// Input	#0	: IMediaData	oCiXg[
/////////////////////////////////////////////////////////////////////////////

class CFileWriter :	public CMediaDecoder,
					public IFileWriter
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CFileWriter)

// IFileWriter
	virtual const bool OpenFile(LPCTSTR lpszFileName, const bool bAsyncWrite = false, const DWORD dwBuffSize = 0UL);
	virtual bool CloseFile(void);
	virtual const ULONGLONG GetFileLength(void);
	
// CFileWriter
	CFileWriter(IBonObject *pOwner);
	virtual ~CFileWriter(void);
	
protected:
// CMediaDecoder
	virtual const bool OnPlay(void);
	virtual const bool OnStop(void);
	virtual const bool OnInputMedia(const IMediaData *pMediaData, const DWORD dwInputIndex = 0UL);

// CFileWriter
	virtual const bool WriteSync(const IMediaData *pMediaData);
	virtual const bool WriteAsync(const IMediaData *pMediaData);
	void WriteThread(CSmartThread<CFileWriter> &thread, const ISignal &bKillSignal, const ULONG_PTR param);

	ISmartFile *m_pFile;
	CSmartThread<CFileWriter> m_WriteThread;

	std::vector<IMediaData *> m_MediaPool;
	std::vector<IMediaData *>::iterator m_itFreeMedia;
	std::queue<IMediaData *> m_MediaQue;
};
