// TsSourceTuner.cpp: TS\[X`[ifR[_
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "TsSourceTuner.h"


/////////////////////////////////////////////////////////////////////////////
// t@C[J萔ݒ
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
// TS\[X`[ifR[_
/////////////////////////////////////////////////////////////////////////////

const bool CTsSourceTuner::OnInputMedia(const IMediaData *pMediaData, const DWORD dwInputIndex)
{
	// ̃fR[_Ƀf[^n
	// ̃NX CQueuedMediaDecoder pĂ̂ŁÃ\bh͏ʂ̃fR[_Ƃ
	// ʂ̃XbhŌĂяoĂB
	return OutputMedia(pMediaData);
}

const DWORD CTsSourceTuner::OpenTuner(LPCTSTR lpszBCId)
{
	CBlockLock lock(m_Lock);

	// UN[Y
	CloseTuner();

	IHalDevice *pHalDevice = 0;
	try
	{
		// `[ĩCX^X𐶐
		pHalDevice = ::BON_SAFE_CREATE<IHalDevice *>(lpszBCId);
		if(pHalDevice == 0)throw (DWORD)EC_INTERNAL_ERR;

		// foCX^Cv`FbN
		if(pHalDevice->GetDeviceType() != ::BON_NAME_TO_GUID(TEXT("IHalTsTuner")))throw (DWORD)EC_INTERNAL_ERR;

		// IHalTsTunerC^tF[X擾
		if(!(m_pHalTsTuner = dynamic_cast<IHalTsTuner *>(pHalDevice)))throw (DWORD)EC_INTERNAL_ERR;

		// o͐ɂ
		m_pHalTsTuner->SetOutputDecoder(this);

		// `[iI[v
		DWORD result = m_pHalTsTuner->OpenTuner();
		if (result != EC_OPEN_SUCCESS)throw result;
	}
	catch(DWORD dwErrCode)
	{
		// G[
		BON_SAFE_RELEASE(pHalDevice);
		m_pHalTsTuner = 0;
		CloseTuner();

		return dwErrCode;
	}

	return EC_OPEN_SUCCESS;
}

const bool CTsSourceTuner::CloseTuner(void)
{
	CBlockLock lock(m_Lock);

	// TSMXbh~
	if(m_bIsPlaying)StopDecoder();

	m_bIsPlaying = false;

	// `[iN[Y
	if(m_pHalTsTuner)m_pHalTsTuner->CloseTuner();

	// `[iCX^XJ
	BON_SAFE_RELEASE(m_pHalTsTuner);
	
	return true;
}

const CBonString CTsSourceTuner::GetDeviceName() const
{
	CBlockLock lock(m_Lock);

	// IHalDeviceC^tF[X擾
	IHalDevice * const pHalDevice = dynamic_cast<IHalDevice *>(m_pHalTsTuner);

	// foCXԂ
	return pHalDevice->GetDeviceName();
}

const DWORD CTsSourceTuner::GetDeviceID() const
{
	CBlockLock lock(m_Lock);

	// foCXԍԂ
	return m_pHalTsTuner->GetDeviceID();
}

const CBonString CTsSourceTuner::GetTuningSpaceName(const DWORD dwSpace) const
{
	CBlockLock lock(m_Lock);

	// `[iI[vĂȂ
	if(!m_pHalTsTuner)return CBonString::GetEmpty();

	// `[jOԖԂ
	return m_pHalTsTuner->EnumTuningSpace(dwSpace);
}

const CBonString CTsSourceTuner::GetChannelName(const DWORD dwSpace, const DWORD dwChannel) const
{
	CBlockLock lock(m_Lock);

	// `[iI[vĂȂ
	if(!m_pHalTsTuner)return CBonString::GetEmpty();

	// `lԂ
	return m_pHalTsTuner->EnumChannelName(dwSpace, dwChannel);
}

const DWORD CTsSourceTuner::GetCurSpace(void) const
{
	CBlockLock lock(m_Lock);

	// ݂̃`[jOԂԂ
	return (m_pHalTsTuner)? m_pHalTsTuner->GetCurSpace() : 0UL;
}

const DWORD CTsSourceTuner::GetCurChannel(void) const
{
	CBlockLock lock(m_Lock);

	// ݂̃`lԂ
	return (m_pHalTsTuner)? m_pHalTsTuner->GetCurChannel() : 0UL;
}

const bool CTsSourceTuner::SetChannel(const DWORD dwSpace, const DWORD dwChannel)
{
	CBlockLock lock(m_Lock);

	// `[iI[vĂȂ
	if(!m_pHalTsTuner)return 0UL;

	// `lύX
	if(!m_pHalTsTuner->SetChannel(dwSpace, dwChannel))return false;
	
	// ʃfR[_Zbg
	ResetDecoder();

	return true;
}

const bool CTsSourceTuner::SetLnbPower(const bool bEnable)
{
	CBlockLock lock(m_Lock);

	// `[iI[vĂȂ
	if(!m_pHalTsTuner)return 0UL;

	return m_pHalTsTuner->SetLnbPower(bEnable);
}

const float CTsSourceTuner::GetSignalLevel(void) const
{
	CBlockLock lock(m_Lock);

	// `[iI[vĂȂ
	if(!m_pHalTsTuner)return 0UL;

	// MxԂ
	return m_pHalTsTuner->GetSignalLevel();
}

CTsSourceTuner::CTsSourceTuner(IBonObject *pOwner, IMediaDataHeap *pHeap)
	: CQueuedMediaDecoder(pOwner, 1UL, 1UL, 1000, pHeap)
	, m_pHalTsTuner(NULL)
	, m_bIsPlaying(false)
{

}

CTsSourceTuner::~CTsSourceTuner(void)
{
	CloseTuner();
}

const bool CTsSourceTuner::OnPlay(void)
{
	CBlockLock lock(m_Lock);

	// `[iI[vĂȂ
	if(!m_pHalTsTuner)return false;

	// łɍĐ
	if(m_bIsPlaying)return true;

	// Xg[ĐԂɂ
	m_bIsPlaying = true;

	return true;
}

const bool CTsSourceTuner::OnStop(void)
{
	CBlockLock lock(m_Lock);

	// `[iI[vĂȂ
	if(!m_pHalTsTuner)return false;

	// Xg[~Ԃɂ
	m_bIsPlaying = false;
	
	return true;
}

