// TsDescBase.cpp: fXNv^NX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "TsDescBase.h"
#include "TsDescriptor.h"


/////////////////////////////////////////////////////////////////////////////
// fXNv^ʃC^tF[XNX
/////////////////////////////////////////////////////////////////////////////

const DWORD CDescBase::ParseDesc(const BYTE *pData, const DWORD dwDataSize)
{
	// Lqq̃ftHg͏
	if(!pData)return 0UL;									// f[^
	else if(dwDataSize < 2U)return 0UL;						// Œł^O+Lqq2oCgKv
	else if(dwDataSize < (WORD)(pData[1] + 2U))return 0UL;	// f[^Lqq̃TCY

	// wb_ۑ
	m_byDescTag = pData[0];
	m_byDescLen = pData[1];

	// f[^|C^ۑ
	m_pDescData = (m_byDescLen)? &pData[2] : NULL;

	if(m_pDescData){
		// f[^
		if(!ParseData())return 0UL;
		}

	return m_byDescLen + 2UL;
}

const BYTE CDescBase::GetTag(void) const
{
	// Lqq^OԂ
	return m_byDescTag;
}

const BYTE CDescBase::GetLength(void) const
{
	// LqqԂ(^OƋLqq͏)
	return m_byDescLen;
}

const BYTE * CDescBase::GetData(void) const
{
	// Lqqf[^Ԃ
	return m_pDescData;
}

CDescBase::CDescBase(IBonObject *pOwner)
	: CBonObject(pOwner)
	, m_byDescTag(0x00U)
	, m_byDescLen(0x00U)
	, m_pDescData(NULL)
{

}

CDescBase::~CDescBase(void)
{

}

const bool CDescBase::ParseData(void)
{
	// ftHg̏ł͉Ȃ(hNXŃI[o[Ch)
	return true;
}


/////////////////////////////////////////////////////////////////////////////
// fXNv^WC^tF[XNX
/////////////////////////////////////////////////////////////////////////////

const DWORD CDescBlock::ParseDescs(void)
{
	// LqqCX^XNA
	for(DWORD dwIndex = 0UL ; dwIndex < m_DescArray.size() ; dwIndex++){
		BON_SAFE_RELEASE(m_DescArray[dwIndex]);
		}
	
	m_DescArray.clear();

	// f[^|C^擾
	const BYTE *pData = GetData();
	if(!pData || (GetSize() < 2UL))return 0UL;

	// Lqq
	CDescBase *pDescBase;
	DWORD dwPos = 0UL;

	while((GetSize() - dwPos) >= 2UL){
		// ^OɑΉLqq̃CX^X
		if(!(pDescBase = CreateDesc(pData[dwPos])))break;

		// Lqq
		if(pDescBase->ParseDesc(&pData[dwPos], GetSize() - dwPos)){
			// Lqqǉ
			m_DescArray.push_back(pDescBase);
			}
		else{
			// Ή or G[
			::BON_ASSERT(false, TEXT("LqqΉ or G[\r\nTag = %02X"), pData[dwPos]);
			
			pDescBase->Release();
			}

		// ͈ʒuXV
		dwPos += (pData[dwPos + 1UL] + 2UL);
		}
		
	return m_DescArray.size();
}

void CDescBlock::Reset(void)
{
	// LqqCX^XNA
	for(DWORD dwIndex = 0UL ; dwIndex < m_DescArray.size() ; dwIndex++){
		BON_SAFE_RELEASE(m_DescArray[dwIndex]);
		}
	
	m_DescArray.clear();

	// f[^NA
	ClearSize();
}

const DWORD CDescBlock::GetDescNum(void) const
{
	// Lqq̐Ԃ
	return m_DescArray.size();
}

const IDescBase * CDescBlock::GetDescByTag(const BYTE byTag, const DWORD dwIndex) const
{
	// w肳ꂽ^ŐLqqԂ
	for(DWORD dwPos = 0UL, dwCount = 0UL ; dwPos < m_DescArray.size() ; dwPos++){
		if(m_DescArray[dwPos]){
			if(m_DescArray[dwPos]->GetTag() == byTag){
				if(dwCount++ == dwIndex){
					return m_DescArray[dwPos];	
					}
				}		
			}
		}

	return NULL;
}

const IDescBase * CDescBlock::GetDescByIndex(const DWORD dwIndex) const
{
	// CfbNXŎw肵LqqԂ
	return (dwIndex < m_DescArray.size())? m_DescArray[dwIndex] : NULL;
}

const bool CDescBlock::CopyDescBlock(const IDescBlock *pSrc)
{
	// IMediaDataC^tF[X擾
	const IMediaData * const pMediaData = dynamic_cast<const IMediaData *>(pSrc);
	if(!pMediaData)return false;	
	
	// ێf[^Zbg
	Reset();
	
	// f[^Rs[A
	if(CMediaData::CopyData(pMediaData)){
		return (ParseDescs())? true : false;		
		}

	return false;
}

const DWORD CDescBlock::CopyData(const IMediaData *pSrc)
{
	// IPsiSectionC^tF[X擾
	const IDescBlock * const pDescBlock = dynamic_cast<const IDescBlock *>(pSrc);

	if(pDescBlock){
		// IDescBlockƂăRs[
		return (CopyDescBlock(pDescBlock))? GetSize() : 0UL;
		}
	else{
		// IMediaDataƂăRs[
		return CMediaData::CopyData(pSrc);
		}
}

IMediaData *CDescBlock::Clone(IMediaDataHeap *pHeap) const
{
	// ftHg̎I[o[ChāAK؂Ȍ^ŐKv
	return InternalClone<CDescBlock>(pHeap);
}

CDescBlock::CDescBlock(IBonObject *pOwner, IMediaDataHeap *pHeap)
	: CMediaData(pOwner, pHeap)
{

}

CDescBlock::~CDescBlock(void)
{
	// LqqCX^XJ
	Reset();
}

CDescBase * CDescBlock::CreateDesc(const BYTE byTag)
{
	// ^OɑΉLqq̃CX^X𐶐
	switch(byTag){
		case CCaMethodDesc::DESC_TAG		: return dynamic_cast<CDescBase *>(CCaMethodDesc::CreateInstance(NULL));
		case CNetworkNameDesc::DESC_TAG		: return dynamic_cast<CDescBase *>(CNetworkNameDesc::CreateInstance(NULL));
		case CServiceListDesc::DESC_TAG		: return dynamic_cast<CDescBase *>(CServiceListDesc::CreateInstance(NULL));
		case CServiceDesc::DESC_TAG			: return dynamic_cast<CDescBase *>(CServiceDesc::CreateInstance(NULL));
		case CShortEventDesc::DESC_TAG		: return dynamic_cast<CDescBase *>(CShortEventDesc::CreateInstance(NULL));
		case CExtendEventDesc::DESC_TAG		: return dynamic_cast<CDescBase *>(CExtendEventDesc::CreateInstance(NULL));
		case CComponentDesc::DESC_TAG		: return dynamic_cast<CDescBase *>(CComponentDesc::CreateInstance(NULL));
		case CStreamIdDesc::DESC_TAG		: return dynamic_cast<CDescBase *>(CStreamIdDesc::CreateInstance(NULL));
		case CContentDesc::DESC_TAG			: return dynamic_cast<CDescBase *>(CContentDesc::CreateInstance(NULL));
		case CAudioComponentDesc::DESC_TAG	: return dynamic_cast<CDescBase *>(CAudioComponentDesc::CreateInstance(NULL));
		default :							  return dynamic_cast<CDescBase *>(CDescBase::CreateInstance(NULL));
		}
}
